/**
 * ETH Zrich; Leitprogramm; Binre Suchbume ----- 
 * Das ist die Klasse eines einzelnen Knotens des Binren Suchbaums. 
 * @author Bjrn Steffen, Timur Erdag, Christina Class
 * @version 1.0 
 */
public class BinSearchTree {
    private int key;
    private BinSearchTree left, right;
    
    public BinSearchTree( int key ) {
        this.key = key;
        left=null;
        right=null;
    }
    
    public BinSearchTree( int key, BinSearchTree left, BinSearchTree right ) {
        this.key = key;
        this.left = left;
        this.right = right;
    }
    
    /**
     * getter Methode fr den Schlssel
     * @return den Schlsselwert
     */
    public int getKey()
    {
        return key;
    }
    
    /**
     * setter Methode fr den Schlssel
     * @param value der neue Schlsselwert
     */
    public void setKey(int value)
    {
        key = value;
    }
    
    
    /**
     * getter Methode fr das rechte Kind
     * @return rechtes Kind
     */
    public BinSearchTree getRight()
    {
        return right;
    }
    
    /**
     * setter Methode fr das rechte Kind
     * @param newRight Referenz auf neues rechtes Kind
     */
    public void setRight(BinSearchTree newRight)
    {
        right=newRight;
    }
    
    /**
     * getter Methode fr das linke Kind
     * @return linkes Kind
     */
    public BinSearchTree getLeft()
    {
        return left;
    }
    
    /**
     * setter Methode fr das linke Kind
     * @param newLeft Referenz auf neues linkes Kind
     */
    public void setLeft(BinSearchTree newLeft)
    {
        left=newLeft;
    }
    
    /**
     * Inorder Ausgabe fr den binren Suchbaum
     * @param node Wurzelknoten des binren Suchbaums, der mit inorder ausgegeben werden soll
     */  
    public void inorder(BinSearchTree node) {
        if (node != null) {
            inorder (node.getLeft());
            System.out.print (" " + node.getKey() + " ");
            inorder (node.getRight());
        }
    }
 

   
    /** 
     * Die Methode gibt zurck, ob der bergebene Wert im Baum vorhanden ist.
     * @param node die Wurzel des Suchbaumes
     * @param key der Suchschlssel
     * @return ob die Suche erfolgreich war
     */
    // Implementiere diese Methode nach den Vorgaben der Aufgabe 4.3.
    // Geben Sie true zurck, wenn der Wert gefunden wurde,
    // false sonst.
    public boolean search(BinSearchTree node, int key) {
		return false;
    }

     
    /**
     * Diese Methode fgt einen neuen Knoten mit dem Schlssel key in den
     * binren Suchbaum ein.
     * Aufruf dieser Methode fr einen Baum mit Wurzel root mit dem Wert 10: 
     * root = insert (root, 10);
     * @param node Wurzel des Baumes
     * @param Schlsselwert, den der neue Knoten haben soll
     * @return die neue Wurzel des Baumes.  
     */
    // Implementieren Sie diese Methode nach den Vorgaben der Aufgabe.
    // Geben Sie zur Kontrolle den Wert jedes besuchten Knoten aus!

    public BinSearchTree insert(BinSearchTree node, int key) 
    {
        return node;
    }


    /**
     * Diese Methode lscht alle Knoten mit dem Schlssel key in dem
     * binren Suchbaum. (Aufgabe 4.13. (Additum))
     * Aufruf dieser Methode fr einen Baum mit Wurzel root mit dem Schlsselwert 10: 
     * root = delete(root, 10);
     * @param node Wurzel des Baumes
     * @param Schlsselwert, den der neue Knoten haben soll
     * @return die neue Wurzel des Baumes.  
     */   
    // Als Additum kann auch das Lschen implementiert werden
    // als //# taucht immer die Zeile des Pseudocodes in der Musterlsung des Leitprogramms auf
    public BinSearchTree delete(BinSearchTree node, int key) 
    {
        return node;
    }
}

